module Xclient
  module Xvideos
    def self.parse(url)
      begin
        @doc = Nokogiri::HTML(open(url))
        Client.new(
          title: title,
          thumbs: thumbs,
          tags: tags,
          embed: embed,
          host: Xclient::XVIDEOS_HOST,
          url: url
        )
      rescue
        raise PasserError, "passer error"
      end
    end

    private
    def self.title
      @doc.css('#main > h2').first.children.first.text.strip
    end

    def self.thumbs
      thumb = []
      embed_attrs = @doc.css('embed').first.attr('flashvars').split('&')
      main_thumb_index = embed_attrs.index{|s| s.include?("url_bigthumb=")}
      main_thumb = embed_attrs[main_thumb_index].split("=").last

      thumb << main_thumb
    end

    def self.embed
      @doc.css('#tabEmbed > input').first.attr :value
    end

    def self.tags
      tags = []
      @doc.css('.video-tags > a').each do |link_tag|
        tags << link_tag.text
      end
      # remove 'more tags'
      tags.pop
      tags
    end
  end
end
